; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    start_in_thread PROTO :DWORD,:DWORD

    THREAD_ARGS STRUCT
      flag  dd ?            ; thread start flag
      stak  dd ?            ; optional thread stack size
      arg1  dd ?
      arg2  dd ?
      arg3  dd ?
      arg4  dd ?
      arg5  dd ?
      arg6  dd ?
      arg7  dd ?
      arg8  dd ?
    THREAD_ARGS ENDS

    td equ <1024>           ; thread recursion depth

    .code

start:
   
; 

    call main
    inkey "Thats all folks, press any key to exit"
    exit

; 

main proc

    LOCAL thst      :THREAD_ARGS
    LOCAL hThread   :DWORD
    LOCAL p_proc    :DWORD

    mov p_proc, OFFSET work_thread

  ; -------------------------------
  ; load the THREAD_ARGS structure
  ; -------------------------------
    mov thst.arg1, 0
    mov thst.arg2, 0
    mov thst.arg3, 0
    mov thst.arg4, 0

    mov thst.stak, 1024             ; 1k stack for first thread

    mov hThread, rv(start_in_thread,p_proc,ADDR thst)
    invoke WaitForSingleObject,hThread,INFINITE

    ret

main endp

; 

start_in_thread proc pproc:DWORD,pstruct:DWORD

    LOCAL tID       :DWORD
    LOCAL hThread   :DWORD

    push esi
    mov esi, pstruct
    mov (THREAD_ARGS PTR [esi]).flag, 1    ; set the flag

    mov hThread, rv(CreateThread,NULL,(THREAD_ARGS PTR [esi]).stak,pproc,pstruct,NULL,ADDR tID)

  ; ---------------------------------------------
  ; block new threads from starting until args
  ; are saved in the current thread being created
  ; ---------------------------------------------
  spinlock:
    cmp (THREAD_ARGS PTR [esi]).flag, 0    ; loop until created thread clears the flag
    jne spinlock
  ; ---------------------------------------------

    mov eax, hThread
    pop esi

    ret

start_in_thread endp

; 

work_thread proc pstruct:DWORD

    LOCAL args[4]   :DWORD
    LOCAL thst      :THREAD_ARGS
    LOCAL hThread   :DWORD
    LOCAL p_proc    :DWORD

    mov p_proc, OFFSET work_thread

  ; --------------------------------------------------------------
  ; load the args to local array before the caller flag is cleared
  ; --------------------------------------------------------------
    mov eax, pstruct
    m2m args[0],  (THREAD_ARGS PTR [eax]).arg1

  ; ------------------------------------
  ; release the thread starter procedure
  ; ------------------------------------
    mov (THREAD_ARGS PTR [eax]).flag, 0    ; clear the flag

  ; ***********************************************************************
  ; ***********************************************************************

    m2m thst.arg1, args[0]
    add thst.arg1, 1                        ; increment the thread depth indicator

    print "Thread depth "
    print str$(thst.arg1)," starting",13,10

    cmp thst.arg1, td                       ; see if it has reached the thread depth limit yet
    jge leaving

    mov thst.stak, 64

    mov hThread, rv(start_in_thread,p_proc,ADDR thst)
    invoke WaitForSingleObject,hThread,INFINITE

  leaving:
    .if thst.arg1 == td                     ; only wait on the highest thread
      inkey "Press a key to exit all of the threads"
    .endif

    print "Thread depth "
    print str$(thst.arg1)," leaving",13,10

  ; ***********************************************************************
  ; ***********************************************************************

    ret

work_thread endp

; 

end start


























